<?php
namespace Payum\Klarna\Invoice\Action;

use Payum\Core\Action\GatewayAwareAction;
use Payum\Core\Bridge\Spl\ArrayObject;
use Payum\Core\Exception\RequestNotSupportedException;
use Payum\Core\Request\Refund;
use Payum\Klarna\Invoice\Request\Api\CreditPart;

class RefundAction extends GatewayAwareAction
{
    /**
     * {@inheritDoc}
     *
     * @param Refund $request
     */
    public function execute($request)
    {
        RequestNotSupportedException::assertSupports($this, $request);

        $details = ArrayObject::ensureArrayObject($request->getModel());

        if ($details['refund_invoice_number']) {
            return;
        }

        $details->validateNotEmpty(array('invoice_number'));

        $this->gateway->execute(new CreditPart($details));
    }

    /**
     * {@inheritDoc}
     */
    public function supports($request)
    {
        return
            $request instanceof Refund &&
            $request->getModel() instanceof \ArrayAccess
        ;
    }
}
